//////////////////////////////////////////////////////////////////////////////
//
// "Embedded C Programming: Techniques and Applications of C and PIC MCUs"
// by Mark Siegusmund
//
// Exercise 15-1
//
// Uses getenv() method to return information about the PIC the program is
// compiled for. 
//
//////////////////////////////////////////////////////////////////////////////

#include <e3.h>

void main(void)
{
   printf("\r\n");
   
   printf("--INFORMATION for %s :%lu--\r\n", getenv ("DEVICE"), getenv ("ID"));
   
   #if getenv ("PROGRAM_MEMORY")>0
   printf("ROM LOCATIONS=%lu\r\n", getenv ("PROGRAM_MEMORY"));
   #endif
   
   #if getenv ("STACK")>0
   printf ("RAM LOCATIONS=%lu\r\n", getenv ("RAM"));
   #endif
   
   #if getenv ("DATA_EEPROM")>0
   printf ("EEPROM LOCATIONS=%lu\r\n", getenv ("DATA_EEPROM"));
   #endif
   
   #if getenv ("READ_PROGRAM")
      printf ("PROGRAM READABLE\r\n") ;
   #endif
   
   #if getenv ("ADC_CHANNELS")>0
   printf ("ADC, %u CHANNELS, RESOLUTION=%u\r\n",  getenv ("ADC_CHANNELS"), getenv ("ADC_RESOLUTION"));
   #endif
   
   #if getenv ("SPI")
      printf ("SPI=TRUE\r\n") ;
   #endif
   
   #if getenv ("USB")
      printf ("USB=TRUE\r\n") ;
   #endif
   
   #if getenv ("CAN")
      printf ("CAN=TRUE\r\n") ;
   #endif
   
   #if getenv ("I2C_SLAVE")
      printf ("I2C SLAVE=TRUE\r\n") ;
   #endif
   
   #if getenv ("I2C_MASTER")
      printf ("I2C MASTER=TRUE\r\n") ;
   #endif
   
   #if getenv ("PSP")
      printf ("PSP=TRUE\r\n") ;
   #endif
   
   #if getenv ("COMP")
      printf ("COMP=TRUE\r\n") ;
   #endif
   
   #if getenv ("VREF")
      printf ("VREF=TRUE\r\n") ;
   #endif
   
   #if getenv ("LCD")
      printf ("LCD=TRUE\r\n") ;
   #endif
   
   #if getenv ("UART")
      printf ("UART=TRUE\r\n");
   #endif
   
   #if getenv ("AUART")
      printf ("ADV UART=TRUE\r\n") ;
   #endif
   
   #if getenv ("CCP0")
      printf ("CCP=TRUE\r\n") ;
   #endif
   
   #if getenv ("TIMER0")
      printf ("TIMER=TRUE\r\n") ;
   #endif
   
   for (;;) ;
}
